#!/usr/bin/env python
# coding:  latin-1
# Autor:   Ingmar Stapel
# Datum:   20190810
# Version: 1.0
# Homepage: http://custom-build-robots.com
# Dieses Programm gibt die Werte eine VL53L1X ToF Sensors
# auf der Konsole aus.

# Es werden verschiedene Python-Klassen importiert, deren Funktionen
# fuer die Programmverarbeitung benoetigt werden.
import time

# Das Programm read_VL53L1X wird als Modul geladen und liesst einen
# ToF VL53L1X Sensor aus.
import read_VL53L1X as dist

# Der gewaehlte ToF Sensor am GPIO Pin 23 wird aktiviert.
dist.start_sensor(23)

# Es werden 30 Messwerte mit der For-Schleife ausgegeben.
for x in range(30):
    # Hier erfolgt der Zugriff auf den aktiven ToF Sensor
    dist_mm = dist.get_distance()
    print("ToF Sensor vorne - GPIO Pin 23:")
    print("Entfernung: {}mm".format(dist_mm))

# Der gewahlte ToF Sensor am GPIO Pin 23 wird inaktiv geschalten.
dist.stop_sensor(23)

time.sleep(0.5)
# Der gewaehlte ToF Sensor am GPIO Pin 24 wird aktiviert.
dist.start_sensor(24)

# Es werden 30 Messwerte mit der For-Schleife ausgegeben.
for x in range(30):
    # Hier erfolgt der Zugriff auf den aktiven ToF Sensor
    dist_mm = dist.get_distance()
    print("ToF Sensor hinten - GPIO Pin 24:")
    print("Entfernung: {}mm".format(dist_mm))

# Der gewahlte ToF Sensor am GPIO Pin 24 wird inaktiv geschalten.
dist.stop_sensor(24)
# Programm Ende