#!/usr/bin/env python
# coding:   latin-1
# Autor:    Ingmar Stapel
# Datum:    20190810
# Version:  2.1
# Homepage: http://custom-build-robots.com
# Mit diesem Programm kann der GPS-Empfaenger ausgelesen werden.

import os
from gps import *
import time
import subprocess
from subprocess import Popen

global process
process = None

# Der Zaehler zeigt dem Anwender, wie oft versucht wurde, 
# die Koordinaten auszulesen.
count = 0

# Der GPSD Daemon wird im Hintergrund gestartet
print("Der GPSD Daemon wird mit dem USB Geraet /dev/ttyACM0 gestartet.")
process = subprocess.Popen(["sudo", "gpsd", "-b", "/dev/ttyACM0", "-F", "/var/run/gpsd.sock", "–G"]) 
print("GPSD PID: ", process.pid)

print("Der GPSD Daemon wurde gestartet.")
time.sleep(2)

# Erzeugen der Session fuer den Zugriff auf den Empfaenger.
session = gps(mode=WATCH_ENABLE)

try:
   while True:
      # Warten, um die while-Schleife etwas zu verzoegern.
      time.sleep(0.5)

      # Loeschen des Terminal-Fensters.
      os.system('clear')

      # Ausgabe der Statuszeile, dass das Programm laeuft.
      print 'Auslesen der GPS-Koordinaten'

      # Der Counter wird hochgesetzt.
      count = count + 1

      # Der Anwender wird ueber den Lesezugriff informiert.
      print 'Zaehler:', count ,' Lesezugriffe.'
      session.next()

      # Wenn der GPS-Empfaenger keinen Fixpunkt findet, 
      # wird der Anwender darueber informiert.
      if session.fix.latitude == 0.0:
         print '-------------------------------------------'
         print 'Es wurden keine GPS-Informationen empfangen'
         print 'Wurde der gpsd-Daemon schon gestartet?'
         print '-------------------------------------------'
      # Werden GPS-Koordinaten empfangen, so werden diese 
      # ausgegeben.
      else:
         print '------------------ GPS-Informationen --------------'
         print 'Breitengrad:  ' , session.fix.latitude
         print 'Laengengrad:  ' , session.fix.longitude
         print 'Zeit utc:     ' , session.utc, \
         session.fix.time
         print '----------------------------------------------------'
# Tippt der Anwender im Terminal-Fenster Strg+c, wird das Programm
# beendet und der GPSD Daemon ebenfalls.
except KeyboardInterrupt:
    print("Programm beendet: ")

# Ende des Programms 