# !/usr/bin/env python
# coding: latin-1
# Autor: Ingmar Stapel
# Datum: 20190824
# Version: 2.1
# Homepage: http://custom-build-robots.com
# Dieses Programm greift auf das Gyroskop des Raspberry Pi
# Sense HAT zu und zeigt die Lage in Grad an.
import sys, tty, termios, os, time
# Es wird die Python-Klasse SenseHat importiert.
from sense_hat import SenseHat
# Hier werden die Variablen der drei Achsen des Gyroskops auf 0 gesetzt.
# So wird ein eventueller Fehler bei der Ausgabe vermieden,
# falls die Variablen leer sein sollten.
x = 0
y = 0
z = 0
# Ein Objekt "sense" wird von der Klasse SenseHat() erzeugt,
# um auf die Sensoren des Sense HAT zugreifen zu koennen.
sense = SenseHat()
# Jetzt wird der Sensor Gyroskop aktiviert.
sense.set_imu_config(False, True, False)
try:
   while True:
      # Hier werden die Werte der drei Achsen x, y und z
      # ausgelesen.
      x, y, z = sense.get_orientation().values()
      # Der Bildschirminhalt wird pro Schleifendurchlauf
      # geloescht.
      os.system('clear')
      # Die Anzeige wird im Terminal-Fenster ausgegeben.
      # Die Werte werden auf eine Nachkommastelle genau gerundet.
      print "Orientierung mit dem Gyroskop:"
      print "Kippen x (pitch): ",round(x,2)
      print "Rollen y (roll): ",round(y,2)
      print "Drehen z (yaw): ",round(z,2)
      # Damit die Schleife geregelt laeuft, wird eine sleep-
      # Phase von 0,1 Sekunden eingelegt.
      time.sleep(0.1)
# Tippt der Anwender im Terminal-Fenster Strg+C, wird das Programm
# beendet und der Sensor des Gyroskops freigegeben.
except KeyboardInterrupt:
   sense.set_imu_config(False, False, False)
# Ende des Programms
